Index: src/backend/commands/vacuumlazy.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/commands/vacuumlazy.c,v
retrieving revision 1.61.2.2
diff -c -p -r1.61.2.2 vacuumlazy.c
*** src/backend/commands/vacuumlazy.c	4 Mar 2006 19:09:23 -0000	1.61.2.2
--- src/backend/commands/vacuumlazy.c	26 Jul 2007 06:01:59 -0000
*************** lazy_truncate_heap(Relation onerel, LVRe
*** 821,828 ****
  	vacrelstats->pages_removed = old_rel_pages - new_rel_pages;
  
  	/*
! 	 * We keep the exclusive lock until commit (perhaps not necessary)?
  	 */
  
  	ereport(elevel,
  			(errmsg("\"%s\": truncated %u to %u pages",
--- 821,829 ----
  	vacrelstats->pages_removed = old_rel_pages - new_rel_pages;
  
  	/*
! 	 * Release our exclusive lock before going away
  	 */
+ 	UnlockRelation(onerel, AccessExclusiveLock);
  
  	ereport(elevel,
  			(errmsg("\"%s\": truncated %u to %u pages",
*************** count_nondeletable_pages(Relation onerel
*** 854,861 ****
  		bool		tupgone,
  					hastup;
  
- 		vacuum_delay_point();
- 
  		blkno--;
  
  		buf = ReadBuffer(onerel, blkno);
--- 855,860 ----
